﻿using System;
using System.ComponentModel.DataAnnotations;
using System.Collections.ObjectModel;

namespace SL5_BOARD.Web.Model
{
    public class BOARD_LIST
    {
        [Key]
        public int BOARD_LIST_IDX { get; set; }
        public string LIST_TITLE { get; set; }
        [Column(TypeName="ntext")]
        [MaxLength]
        public string LIST_CONTENT { get; set; }
        public bool LIST_ATTACH_YN { get; set; }
        public int LIST_SEQ { get; set; }
        public int LIST_LEVEL { get; set; }
        public int LIST_VIEW_COUNT { get; set; }
        public string LIST_WRITER_NAME { get; set; }
        [DataType(DataType.Password)]
        public string LIST_PASSWORD { get; set; }
        public string LIST_KIND { get; set; }
        public int LIST_COMPLETE_GB { get; set; }
        public bool LIST_OPEN_YN { get; set; }
        public int LIST_GOOD_COUNT { get; set; }
        public int LIST_PUBLIC_GB { get; set; }

        public DateTime REG_DT { get; set; }
        public int REG_IDX { get; set; }
        public DateTime? UPT_DT { get; set; }
        public int? UPT_IDX { get; set; }

        public int BOARD_MAIN_IDX { get; set; }
        public virtual BOARD_MAIN BoardMain { get; set; }

        public int MST_MEMBER_IDX { get; set; }
        public virtual MST_MEMBER MstMember { get; set; }

        public virtual ObservableCollection<BOARD_REPLY> BoardReplys { get; set; }
        public virtual ObservableCollection<BOARD_ATTACH> BoardAttachs { get; set; }

        public BOARD_LIST()
        {
            LIST_ATTACH_YN = false;
            LIST_SEQ = 0;
            LIST_LEVEL = 1;
            LIST_VIEW_COUNT = 0;
            LIST_COMPLETE_GB = 0;
            LIST_OPEN_YN = true;
            LIST_GOOD_COUNT = 0;
            LIST_PUBLIC_GB = 0;

            BoardReplys = new ObservableCollection<BOARD_REPLY>();
            BoardAttachs = new ObservableCollection<BOARD_ATTACH>();
        }
    }
}