﻿using System.Data.Entity;
using System.Web;
using System;
using System.Data.Entity.ModelConfiguration.Conventions;

namespace SL5_BOARD.Web.Model
{
    public class SL5_BOARD_DBCONTEXT : DbContext
    {
        public SL5_BOARD_DBCONTEXT()
            : base("SL5_BOARD")
        {
            //디자인타임이 아닌경우
            if (HttpContext.Current == null)
            {
                //데이터베이스 초기화
                Database.SetInitializer<SL5_BOARD_DBCONTEXT>(new SL5_BOARD_DBCONTEXTInitializer());
            }
        }

        public DbSet<MST_MEMBER> MST_MEMBERS { get; set; }
        public DbSet<BOARD_MAIN> BOARD_MAINS { get; set; }
        public DbSet<BOARD_LIST> BOARD_LISTS { get; set; }
        public DbSet<BOARD_REPLY> BOARD_REPLYS { get; set; }
        public DbSet<BOARD_ATTACH> BOARD_ATTACHS { get; set; }

        //모델이 만들어 지면서..테이블과의 관계를 줄 수 있는데..좀 뒤로 미룬다
        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Conventions.Remove<PluralizingTableNameConvention>();

            //modelBuilder.Entity<BOARD_REPLY>()
            //    .HasRequired(a => a.MstMember).WithMany();

            //    .HasOptional(p => p.OfficeAssignment).WithRequired(p => p.Instructor);
            //modelBuilder.Entity<Course>()
            //    .HasMany(c => c.Instructors).WithMany(i => i.Courses)
            //    .Map(t => t.MapLeftKey("CourseID")
            //        .MapRightKey("InstructorID")
            //        .ToTable("CourseInstructor"));
            //modelBuilder.Entity<Department>()
            //    .HasOptional(x => x.Administrator);
        }

    }

    //데이터베이스를 새로 만들었을 때
    public class SL5_BOARD_DBCONTEXTInitializer
        : CreateDatabaseIfNotExists<SL5_BOARD_DBCONTEXT>
    {
        //초기값을 넣어준다.
        protected override void Seed(SL5_BOARD_DBCONTEXT context)
        {
            var admin_member = new MST_MEMBER
            {
                EMAIL = "admin@localhost",
                PASSWORD = "p@ssw0rd",
                MEMBER_NAME = "관리자",
                NICK_NAME = "관리자",
                DESCRIPTION = "사이트 관리하는 슈퍼 유저",
                MEMBER_SCORE = 1000,
                MEMBER_GRADE = "Z",
                STATUS = 1,
                REG_DT = DateTime.Now,
                REG_IDX = 1
            };
            context.MST_MEMBERS.Add(admin_member);
            context.SaveChanges();

            var test_board = new BOARD_MAIN
            {
                BOARD_NAME = "Kakisoft MainPage",
                BOARD_DESC = "Kakisoft Main 페이지 입니다.",
                BOARD_TYPE = "NOR",
                MEMBER_CHECK = false,
                BOARD_STATE = "02",
                BOARD_ORDER = 1,
                REG_DT = DateTime.Now,
                REG_IDX = 1
            };
            context.BOARD_MAINS.Add(test_board);
            context.SaveChanges();
        }
    }
}