﻿using System;
using System.Text;
using System.Windows.Data;

namespace SL5_BOARD.Converter
{
    public class TextToXMLConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string text = value as string;
            StringBuilder sb = new StringBuilder();

            if (text == null)
                text = string.Empty;

            if (text.Contains("xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\"") == false)
            {
                //sb.AppendLine("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
                sb.AppendLine("<Section xml:space=\"preserve\" xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\">");
                sb.AppendLine("    <Paragraph>");
                sb.AppendLine("        <Run>" + text + "</Run>");
                sb.AppendLine("    </Paragraph>");
                sb.AppendLine("</Section>");
            }
            else
            {
                sb.Append(text);
            }
            return sb.ToString();
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string xml = value as string;

            return xml;
        }
    }
}
