﻿
using System.ComponentModel;
using System.ComponentModel.Composition;
using SL5_BOARD.Web.DomainService;

namespace SL5_BOARD.Models
{
    [Export(typeof(BoardContext))]
    public class BoardContext : INotifyPropertyChanged
    {
        SL5_BOARDDomainContext context;
        public SL5_BOARDDomainContext Context
        {
            get
            {
                return context;
            }

            private set
            {
                if (context != null)
                {
                    context = value;
                    OnPropertyChanged("Context");
                }
            }
        }

        #region PropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string PropertyName)
        {
            if (PropertyChanged != null)
            { 
                PropertyChanged(this, new PropertyChangedEventArgs(PropertyName));
            }
        } 
        #endregion

        public BoardContext()
        {
            context = new SL5_BOARDDomainContext();
        }


    }
}
